import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class midlet extends MIDlet implements CommandListener { 
 public List props;
 public recordStores rs=null;
 public Command Add,Change,Delete,Up,Down,Copy,Sort,ClearAll,Quit,Back,Ok,Help,About,Yes,No;
 int n;
 boolean changed=false, readed=false;
 TextBox editForm;
 Form confirmForm;
 gaugeForm gauge;
 StringItem msg;
 int mode; //0-,1-,2-

 public String getMainTitle () {
  return Locale.mainHeader+" ("+props.size()+")";
 }

 public void setMainTitle () {
  props.setTitle (getMainTitle());
 }

 public midlet () {
  Back = new Command(Locale.Back, Command.BACK, 0);
  Ok = new Command(Locale.Ok, Command.OK, 0);
  Quit = new Command(Locale.Quit, Command.EXIT, 0);
  Add = new Command(Locale.Add, Command.ITEM, 2);
  Change = new Command(Locale.Change, Command.ITEM, 2);
  Delete = new Command(Locale.Delete, Command.ITEM, 2);
  Up = new Command(Locale.Up, Command.ITEM, 2);
  Down = new Command(Locale.Down, Command.ITEM, 2);
  Copy =  new Command(Locale.Copy, Command.ITEM, 2);
  Sort =  new Command(Locale.Sort, Command.ITEM, 2);
  ClearAll =  new Command(Locale.ClearAll, Command.ITEM, 2);
  Help = new Command(Locale.Help, Command.ITEM, 3);
  About = new Command(Locale.About, Command.ITEM, 3);
  Yes = new Command(Locale.Yes, Command.OK, 0);
  No = new Command(Locale.No, Command.BACK, 0);

  props = new List (Locale.mainHeader, List.IMPLICIT);
  props.addCommand (Add);
  props.addCommand (Change);
  props.addCommand (Delete);
  props.addCommand (Up);
  props.addCommand (Down);
  props.addCommand (Copy);
  props.addCommand (Sort);
  props.addCommand (ClearAll);
  props.addCommand (Help);
  props.addCommand (About);
  props.addCommand (Quit);

  editForm = new TextBox (Locale.Property,"",256,TextField.ANY);
  editForm.addCommand(Back);
  editForm.addCommand(Ok);
  editForm.setCommandListener(this);

  confirmForm = new Form (Locale.WarningHeader);
  confirmForm.addCommand(No);
  confirmForm.addCommand(Yes);
  msg=new StringItem ("",Locale.ConfirmMessage);
  confirmForm.append (msg);
  confirmForm.setCommandListener(this);

  mode=0;

 }

 protected void destroyApp(boolean unconditional) { 
  String item; 
  int k=1;
  if (changed==true) {
   gauge = new gaugeForm (this,props,Locale.PackStr,1,rs.getNumRecords());
   Display.getDisplay(this).setCurrent(gauge);
   for (int l=0; l<props.size(); l++) {
    item=props.getString (l);
    rs.setRecord (k,item);
//System.out.println ("l="+l+" k="+k+" item="+item);//!!!
    gauge.draw (k);
    k++;
   }
//System.out.println ("all="+rs.getNumRecords());//!!!
   if (k<=rs.getNumRecords()) {
    for (int l=k; l<=rs.getNumRecords(); l++) {
     rs.setRecord (l,"");
     gauge.draw (l);
    }
   }
  }
  rs.closeRecords ();
  gauge=null;
 }

 protected  void pauseApp() { }

 protected void startApp() {
  if (readed == false) {
   rs = new recordStores ();
   if (rs.getNumRecords() < 1) {
    //props.append ("MPJC_CID",null);
    //props.append ("MPJC_LAC",null);
    props.append ("microedition.io.file.FileConnection.version",null);
    changed=true;
   }
   else {
    gauge = new gaugeForm (this,props,Locale.LoadStr,1,rs.getNumRecords());
    Display.getDisplay(this).setCurrent(gauge);
    String s;
    for (int n=0; n<rs.getNumRecords(); n++) {
     s=rs.getRecord (n+1);
//System.out.println ("Read:"+s);//!!!
     if (s!=null) if (s.trim().length()>0) { props.append (s,null); }
     gauge.draw (n);
    }
   }
   readed = true;
  }
  setMainTitle ();
  Display.getDisplay(this).setCurrent(props);
  props.setCommandListener(this);
 }

 public void quit() { 
  destroyApp(true);
  notifyDestroyed();
 }

 public void Go () {
  try {
   String s,res;
   s = props.getString(props.getSelectedIndex());
//System.out.println (s);//!!!
   res = System.getProperty (s);
//System.out.println ("Key: "+s+"\nValue: "+res);//!!!
   new Message (this, props, Locale.Property).show ("Key: "+s+"\nValue: "+res);
  }
  catch (NullPointerException e) {
   new Message (this, props, Locale.About).show (Locale.NullPtrMsg);
   return;
  }
  catch (IllegalArgumentException e) {
   new Message (this, props, Locale.About).show (Locale.IllegalArgMsg);
   return;
  }
 }

 public void commandAction(Command c, Displayable d) {
  if (c==List.SELECT_COMMAND) {
   Go ();
  }
  else {
   if (c == Back) { 
    mode=0;
    Display.getDisplay(this).setCurrent(props);
   }
   else if (c== Add) {
    n = props.getSelectedIndex ();
    mode=1;
    editForm.setString ("");
    Display.getDisplay(this).setCurrent(editForm);
   }
   else if (c== Change) {
    n = props.getSelectedIndex ();
    if (n>-1) {
     mode=2;
     editForm.setString (props.getString(n));
     Display.getDisplay(this).setCurrent(editForm);
    }
   }
   else if (c== Delete) {
    if (props.size()>0) {
     n = props.getSelectedIndex ();
     if (n>-1) {
      props.delete (n);
      changed=true;
      if (props.size()<1) new Message (this, props, Locale.WarningHeader).show (Locale.VoidListMessage);
      setMainTitle ();
     }
    }
   }
   else if (c== Up) {
    if (props.size()>1) {
     n = props.getSelectedIndex ();
     if (n>0) {
      String s=props.getString (n);
      props.delete (n);
      props.insert (n-1,s,null);
      props.setSelectedIndex (n-1,true);
      changed=true;
     }
    }
   }
   else if (c== Down) {
    if (props.size()>1) {
     n = props.getSelectedIndex ();
     if (n<props.size()-1) {
      String s=props.getString (n);
      props.delete (n);
      if (n==props.size()-1) {
       props.append (s,null);
       props.setSelectedIndex (props.size()-1,true);
      }
      else {
       props.insert (n+1,s,null);
       props.setSelectedIndex (n+1,true);
      }
      changed=true;
     }
    }
   }
   else if (c == Ok) {
    String txt = editForm.getString().trim();
    if (txt.length()<1) {
     new Message (this, props, Locale.WarningHeader).show (Locale.VoidFieldMessage);
     return;
    }
    if (mode == 1) {
     if (n<0) { props.append (txt, null); }
     else { props.insert (n, txt, null); }
     setMainTitle ();
     changed=true;
    }
    else if (mode == 2) {
     props.set (n, txt, null);
     changed=true;
    }
    mode=0;
    Display.getDisplay(this).setCurrent(props);
   }
   else if (c == ClearAll) {
    Display.getDisplay(this).setCurrent(confirmForm);
   }
   else if (c == Yes) {
    boolean res = false;
    if (rs.closeRecords() == true) {
     if (rs.deleteAll () == true) {
      rs = new recordStores ();
      if (rs.getNumRecords() < 1) {
       while (props.size()>0) { props.delete (0); }
       setMainTitle ();
       res = true;
       changed = true;
      }
     }
    }
    if (res == true) {
     new Message (this, props, Locale.mainHeader).show (Locale.AllDeletedMessage);
    }
    else {
     new Message (this, props, Locale.mainHeader).show (Locale.NotDeletedMessage);
    }
   }
   else if (c == No) {
    Display.getDisplay(this).setCurrent(props);
   }
   else if (c == Copy) {
    if (props.size()>0) {
     n = props.getSelectedIndex ();
     props.insert (n, props.getString(n), null); 
     setMainTitle ();
     changed=true;
    }
   }
   else if (c == Sort) {
    if (props.size()>1) {
     String s; int i,j;
     gauge = new gaugeForm (this,props,Locale.SortStr,1,props.size()-1);
     Display.getDisplay(this).setCurrent(gauge);
     for (i=0; i<props.size()-1; i++) {
      gauge.draw (i);
      for (j=i+1; j<props.size(); j++) {
       if (props.getString(i).compareTo(props.getString(j))>0) {
        s = props.getString (i);
        props.set (i,props.getString(j),null);
        props.set (j,s,null);
       }
      }
     }
     gauge.close ();
    }
   }
   else if (c == Help) {
    new Message (this, props, Locale.Help).show (Locale.HelpTxt);
   }
   else if (c == About) {
    new Message (this, props, Locale.About).show (Locale.AboutTxt);
   }
   else if (c == Quit) {
    quit();
   }
   else {
    return;
   }
  }
 }

}
